// FontPixels
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
        EndDialog(hwnd, IDOK);
        break;
    case IDCANCEL:
        EndDialog(hwnd, IDCANCEL);
        break;
    }
}

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    if (HDC hDC = BeginPaint(hwnd, &ps))
    {
        RECT rc;
        GetClientRect(hwnd, &rc);

        INT x = 30, y = 30;
        MoveToEx(hDC, rc.left, y, NULL);
        LineTo(hDC, rc.right, y);
        MoveToEx(hDC, x, rc.top, NULL);
        LineTo(hDC, x, rc.bottom);

        LOGFONT lf;
        ZeroMemory(&lf, sizeof(lf));
        lf.lfHeight = 12;
        lf.lfQuality = NONANTIALIASED_QUALITY;
        lstrcpy(lf.lfFaceName, TEXT("DejaVu Sans"));

        if (HFONT hFont = CreateFontIndirect(&lf))
        {
            static const LPCTSTR pszText = TEXT("Test");

            HGDIOBJ hFontOld = SelectObject(hDC, hFont);

            SIZE siz;
            GetTextExtentPoint32(hDC, pszText, lstrlen(pszText), &siz);

            SetRect(&rc, x, y, x + siz.cx, y + siz.cy);
            InflateRect(&rc, 2, 2);

            SelectObject(hDC, GetStockObject(NULL_BRUSH));
            Rectangle(hDC, rc.left, rc.top, rc.right, rc.bottom);

            SetTextColor(hDC, RGB(0, 0, 0));
            SetBkColor(hDC, RGB(0, 255, 255));
            SetBkMode(hDC, OPAQUE);
            TextOut(hDC, x, y, pszText, lstrlen(pszText));

            SelectObject(hDC, hFontOld);
            DeleteObject(hFont);
        }

        EndPaint(hwnd, &ps);
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
